%global momorel 2

Summary: Device-mapper RAID tool and library
Name: dmraid
Version: 1.0.0.rc15
Release: %{momorel}m%{?dist}
License: GPLv2+
Group: System Environment/Base
URL: http://people.redhat.com/heinzm/sw/dmraid
Source: http://people.redhat.com/~heinzm/sw/dmraid/src/dmraid-%{version}.tar.bz2
Patch0: dmraid-1.0.0.rc15-whitespace.patch
Patch1: dmraid-1.0.0.rc15-isw-raid10.patch
Patch2: dmraid-1.0.0.rc15-rm_partitions.patch
Patch3: dmraid-1.0.0.rc15-isw-serial.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: device-mapper >= 1.02.02, libselinux-devel, libsepol-devel, zlib-devel
Requires: kpartx
Requires: device-mapper >= 1.02.02

%description
DMRAID supports RAID device discovery, RAID set activation, creation,
removal, rebuild and display of properties for ATARAID/DDF1 metadata on
Linux >= 2.4 using device-mapper.

%package devel
Summary: Development libraries and headers for dmraid.
Group: Development/Libraries
License: GPLv2+
Requires: %{name} = %{version}-%{release}
Requires: %{name}-libs = %{version}-%{release}

%description devel
dmraid-devel provides a library interface for RAID device discovery,
RAID set activation, creation, removal, rebuild and display of
properties for ATARAID/DDF1 metadata.

%package libs
Summary: Shared library for RAID device discovery
Group: System Environment/Libraries
License: GPLv2+

%description libs
This package contains the dmraid shared library, libdmraid.

%prep
%setup -q -n dmraid/%{version}

%patch0 -p1 -b .whitespace
%patch1 -p1 -b .isw-raid10
%patch2 -p1 -b .rm_partitions
%patch3 -p1 -b .isw-serial

%build
%configure --prefix=${RPM_BUILD_ROOT}/usr --sbindir=${RPM_BUILD_ROOT}/sbin --libdir=${RPM_BUILD_ROOT}/%{_libdir} --mandir=${RPM_BUILD_ROOT}/%{_mandir} --includedir=${RPM_BUILD_ROOT}/%{_includedir} --enable-debug --enable-libselinux --enable-libsepol --enable-static_link
make DESTDIR=$RPM_BUILD_ROOT LDFLAGS="-L%{_lib}"
mv tools/dmraid tools/dmraid.static
make clean
%configure --prefix=${RPM_BUILD_ROOT}/usr --sbindir=${RPM_BUILD_ROOT}/sbin --libdir=${RPM_BUILD_ROOT}/%{_libdir} --mandir=${RPM_BUILD_ROOT}/%{_mandir} --includedir=${RPM_BUILD_ROOT}/%{_includedir} --enable-debug --enable-libselinux --enable-libsepol --disable-static_link
make -C lib DESTDIR=$RPM_BUILD_ROOT libdmraid.so

%install
rm -rf %{buildroot}
install -m 755 -d %{buildroot}{%{_libdir},/sbin,%{_sbindir},%{_bindir},%{_libdir},%{_includedir}/dmraid/,/var/lock/dmraid}
make DESTDIR=$RPM_BUILD_ROOT install
install -m 755 tools/dmraid.static %{buildroot}/sbin/dmraid.static
install -m 644 include/dmraid/*.h %{buildroot}%{_includedir}/dmraid/

# if requested, install the dso
install -m 755 lib/libdmraid.so \
	%{buildroot}%{_libdir}/libdmraid.so.%{version}
(cd %{buildroot}/%{_libdir} ; ln -sf libdmraid.so.%{version} libdmraid.so)

rm -f %{buildroot}%{_libdir}/libdmraid.a

%clean
rm -rf %{buildroot}

%post -p /sbin/ldconfig
 
%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc CHANGELOG CREDITS KNOWN_BUGS LICENSE LICENSE_GPL LICENSE_LGPL README TODO doc/dmraid_design.txt
/%{_mandir}/man8/dmraid.8*
/sbin/dmraid
/sbin/dmraid.static
/var/lock/dmraid

%files -n dmraid-devel
%defattr(-,root,root)
%dir %{_includedir}/dmraid
%{_includedir}/dmraid/*.h
%attr(755,root,root) %{_libdir}/libdmraid.so

%files libs
%attr(755,root,root) %{_libdir}/libdmraid.so.*

%changelog
* Mon Jun  1 2009 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.0.0-rc15-2m)
- add LDFLAGS (build fix)

* Wed May  5 2009 YAMAZAKI Makoto <zaki@zakky.org>
- (1.0.0.rc15-1m)
- sync with fedora 1.0.0rc15-7

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0.0.rc14-4m)
- rebuild against rpm-4.6

* Mon May  5 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0.0.rc14-3m)
- import fedora patches(dmraid-1.0.0.rc14-6)

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.0.0.rc14-2m)
- rebuild against gcc43

* Wed May  2 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0.0.rc14-1m)
- update dmraid-1.0.0.rc14

* Tue Dec 12 2006 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (1.0.0.rc13-1m)
- sync with dmraid-1.0.0.rc13-1.fc6

* Wed Oct 18 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0.0.rc9-3m)
- maki modosi

* Wed Oct 18 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0.0.rc13-1m)
- update 1.0.0.rc13

* Wed May 24 2006 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- fix build. new "install" command fail with -o, -g option.

* Wed Dec 28 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.0.rc9-1m)
- import from fc-devel

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Sun Dec  3 2005 Peter Jones <pjones@redhat.com> 1.0.0.rc9-FC5_4
- rebuild for device-mapper-1.02.02-2

* Fri Dec  2 2005 Peter Jones <pjones@redhat.com> 1.0.0.rc9-FC5_3
- rebuild for device-mapper-1.02.02-1

* Thu Nov 10 2005 Peter Jones <pjones@redhat.com> 1.0.0.rc9-FC5_2
- update to 1.0.0.rc9
- make "make install" do the right thing with the DSO
- eliminate duplicate definitions in the headers
- export more symbols in the DSO
- add api calls to retrieve dm tables
- fix DESTDIR for 'make install' 
- add api calls to identify degraded devices
- remove several arch excludes

* Sat Oct 15 2005 Florian La Roche <laroche@redhat.com>
- add -lselinux -lsepol for new device-mapper deps

* Fri May 20 2005 Heinz Mauelshagen <heinzm@redhat.com> 1.0.0.rc8-FC4_2
- specfile change to build static and dynamic binray into one package
- rebuilt

* Thu May 19 2005 Heinz Mauelshagen <heinzm@redhat.com> 1.0.0.rc8-FC4_1
- nv.c: fixed stripe size
- sil.c: avoid incarnation_no in name creation, because the Windows
         driver changes it every time
- added --ignorelocking option to avoid taking out locks in early boot
  where no read/write access to /var is given

* Wed Mar 16 2005 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Mar 15 2005 Heinz Mauelshagen <heinzm@redhat.com> 1.0.0.rc6.1-4_FC4
- VIA metadata format handler
- added RAID10 to lsi metadata format handler
- "dmraid -rD": file device size into {devicename}_{formatname}.size
- "dmraid -tay": pretty print multi-line tables ala "dmsetup table"
- "dmraid -l": display supported RAID levels + manual update
- _sil_read() used LOG_NOTICE rather than LOG_INFO in order to
  avoid messages about valid metadata areas being displayed
  during "dmraid -vay".
- isw, sil filed metadata offset on "-r -D" in sectors rather than in bytes.
- isw needed dev_sort() to sort RAID devices in sets correctly.
- pdc metadata format handler name creation. Lead to
  wrong RAID set grouping logic in some configurations.
- pdc RAID1 size calculation fixed (rc6.1)
- dos.c: partition table code fixes by Paul Moore
- _free_dev_pointers(): fixed potential OOB error
- hpt37x_check: deal with raid_disks = 1 in mirror sets
- pdc_check: status & 0x80 doesn't always show a failed device;
  removed that check for now. Status definitions needed.
- sil addition of RAID sets to global list of sets
- sil spare device memory leak
- group_set(): removal of RAID set in case of error
- hpt37x: handle total_secs > device size
- allow -p with -f
- enhanced error message by checking target type against list of
  registered target types

* Fri Jan 21 2005 Alasdair Kergon <agk@redhat.com> 1.0.0.rc5f-2
- Rebuild to pick up new libdevmapper.

* Fri Nov 26 2004 Heinz Mauelshagen <heinzm@redhat.com> 1.0.0.rc5f
- specfile cleanup

* Tue Aug 20 2004 Heinz Mauelshagen <heinzm@redhat.com> 1.0.0-rc4-pre1
- Removed make flag after fixing make.tmpl.in

* Tue Aug 18 2004 Heinz Mauelshagen <heinzm@redhat.com> 1.0.0-rc3
- Added make flag to prevent make 3.80 from looping infinitely

* Thu Jun 17 2004 Heinz Mauelshagen <heinzm@redhat.com> 1.0.0-pre1
- Created
